GNU bug report logs - #60014
[PATCH v2] doc: Clarify special-files-service-type expected value.

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: mirai@HIDDEN; Keywords: patch; dated Mon, 12 Dec 2022 17:47:01 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.
Changed bug title to '[PATCH v2] doc: Clarify special-files-service-type expected value.' from '[PATCH] activation: make install-special-file match against pairs as well.' Request was from mirai <mirai@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 21 Dec 2022 13:32:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 21 08:32:19 2022
Received: from localhost ([127.0.0.1]:51909 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p7zCl-0003lH-6n
	for submit <at> debbugs.gnu.org; Wed, 21 Dec 2022 08:32:19 -0500
Received: from smtpmciv5.myservices.hosting ([185.26.107.241]:37712)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p7zCi-0003lB-IH
 for 60014 <at> debbugs.gnu.org; Wed, 21 Dec 2022 08:32:17 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv5.myservices.hosting (Postfix) with ESMTP id 5075720C97
 for <60014 <at> debbugs.gnu.org>; Wed, 21 Dec 2022 14:32:08 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id CAB3A80098;
 Wed, 21 Dec 2022 14:32:03 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id X7dovFQXvTVq; Wed, 21 Dec 2022 14:32:02 +0100 (CET)
Received: from guix-nuc.home.arpa (bl12-93-156.dsl.telepac.pt [85.245.93.156])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 890B780097;
 Wed, 21 Dec 2022 14:32:02 +0100 (CET)
From: mirai@HIDDEN
To: 60014 <at> debbugs.gnu.org
Subject: [PATCH v2] doc: Clarify special-files-service-type expected value.
Date: Wed, 21 Dec 2022 13:31:44 +0000
Message-Id: <f0c786997ad95cfacee70648a22e74dc5348c823.1671629504.git.mirai@HIDDEN>
X-Mailer: git-send-email 2.38.1
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 60014
Cc: Bruno Victal <mirai@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

From: Bruno Victal <mirai@HIDDEN>

* doc/guix.texi (Services, Base Services): Clarify special-files-service-type
expected value.
---
 doc/guix.texi | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/doc/guix.texi b/doc/guix.texi
index fd03da8c97..a9b6e1231d 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -17753,7 +17753,7 @@ This is the service that sets up ``special files'' such as
 @file{/bin/sh}; an instance of it is part of @code{%base-services}.
 
 The value associated with @code{special-files-service-type} services
-must be a list of tuples where the first element is the ``special file''
+must be a list of two-element lists where the first element is the ``special file''
 and the second element is its target.  By default it is:
 
 @cindex @file{/bin/sh}

base-commit: 7833acab0da02335941974608510c02e2d1d8069
-- 
2.38.1





Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 21 Dec 2022 13:21:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 21 08:21:09 2022
Received: from localhost ([127.0.0.1]:51850 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p7z1x-0003cu-42
	for submit <at> debbugs.gnu.org; Wed, 21 Dec 2022 08:21:09 -0500
Received: from smtpm3.myservices.hosting ([185.26.105.234]:46270)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p7z1r-0003co-KM
 for 60014 <at> debbugs.gnu.org; Wed, 21 Dec 2022 08:21:07 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpm3.myservices.hosting (Postfix) with ESMTP id D0A1420DD4;
 Wed, 21 Dec 2022 14:20:58 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id 4586780096;
 Wed, 21 Dec 2022 14:20:58 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id Zo6O-6mUsb2C; Wed, 21 Dec 2022 14:20:57 +0100 (CET)
Received: from [192.168.1.239] (unknown [10.192.1.83])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 7B72680093;
 Wed, 21 Dec 2022 14:20:57 +0100 (CET)
Message-ID: <15a36fc9-05ce-d599-5539-166de64e9f04@HIDDEN>
Date: Wed, 21 Dec 2022 13:20:51 +0000
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:102.0) Gecko/20100101
 Thunderbird/102.5.1
Subject: Re: bug#60014: [PATCH] activation: make install-special-file match
 against pairs as well.
Content-Language: en-US
To: =?UTF-8?Q?Ludovic_Court=c3=a8s?= <ludo@HIDDEN>,
 Josselin Poiret <dev@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN> <87ili66sk1.fsf_-_@HIDDEN>
From: mirai <mirai@HIDDEN>
In-Reply-To: <87ili66sk1.fsf_-_@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi, While thinking about this, I've noticed that using lists
 as "pairs" is a pattern that is common in the existing guix code,
 with openssh-service-type
 'authorized-keys' field and G-Expressions 'file-uni [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 NICE_REPLY_A           Looks like a legit reply (A)
X-Debbugs-Envelope-To: 60014
Cc: 60014 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Hi,

While thinking about this, I've noticed that using lists as "pairs"
is a pattern that is common in the existing guix code, with openssh-service-type
'authorized-keys' field and G-Expressions 'file-union' as examples.

Given the "entrenched" list usage, I don't think it's worth the effort to
change the whole system to use pairs at this point (or maybe allow it as it
probably just creates more confusion).

I will amend the special-files-service-type doc entry to clarify
that it expects two-element lists instead.

Bruno


On 2022-12-20 14:47, Ludovic Courtès wrote:
> Hi,
> 
> Josselin Poiret <dev@HIDDEN> skribis:
> 
>> Is this patch related to some specific problem you're running into?  I
>> personally would prefer keeping the special file interface as-is, and
>> not mix two different kinds of entries: lists with 2 elements, and
>> pairs.  That would avoid having to manage even more edge-cases down the
>> line if some more processing is needed.
> 
> I agree.  This is a public-facing interface so we should keep it as-is;
> extending it to support pairs in addition to two-list elements would
> likely bring confusion and bugs.
> 
> I’m not entirely sure why we settled on two-list elements rather than
> pairs back then, but I think it’s OK.
> 
> Closing?
> 
> Ludo’.




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 20 Dec 2022 14:47:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 20 09:47:22 2022
Received: from localhost ([127.0.0.1]:45280 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p7dtq-0005La-2i
	for submit <at> debbugs.gnu.org; Tue, 20 Dec 2022 09:47:22 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46590)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1p7dtn-0005LU-IV
 for 60014 <at> debbugs.gnu.org; Tue, 20 Dec 2022 09:47:20 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1p7dth-000302-Fg; Tue, 20 Dec 2022 09:47:13 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:In-Reply-To:Date:References:Subject:To:
 From; bh=ZPRGVSPqn/sBzq4f4gI2HAPMs1uQ7T3/6xPNba//yeQ=; b=c4i6DX17IQ0+95x1YP31
 BTGmSj+6+iEJ/dDHu2ImX4Z2zAB8cZ865uV63PH+vO4JbQAxSPczMHzRSCYhHP/Rv7R9yFG7W4TQW
 hoAmoLlWl6gYcbBDNRdyu9yBUhiBae9gbzsiTSfXFcHNgTWU6rfHxvpUkg9lJHh1lbeQUcEwGG7TP
 5KQJtgDkGsMvkAqQcS6bJiOkR1tVhdF8tMH9Hj2Nm4zbbhCL6fMnmkXW9apNCEd1hH/OVCwpyTcCB
 axLqCEkeElBAIpY8cwCMWq5DxsvwnjiB+8hxAlPME6MFf2tdaW1XSbnIPXjY1+WvKxGypwDZIJxeS
 L5ja8ERG8Qg74Q==;
Received: from [193.50.110.60] (helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>)
 id 1p7dth-0005ee-0K; Tue, 20 Dec 2022 09:47:13 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Josselin Poiret <dev@HIDDEN>
Subject: Re: bug#60014: [PATCH] activation: make install-special-file match
 against pairs as well.
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
Date: Tue, 20 Dec 2022 15:47:10 +0100
In-Reply-To: <87k02wfjk5.fsf@HIDDEN> (Josselin Poiret's message of "Mon, 
 12 Dec 2022 21:34:02 +0100")
Message-ID: <87ili66sk1.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.3 (/)
X-Debbugs-Envelope-To: 60014
Cc: 60014 <at> debbugs.gnu.org, mirai@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.3 (-)

Hi,

Josselin Poiret <dev@HIDDEN> skribis:

> Is this patch related to some specific problem you're running into?  I
> personally would prefer keeping the special file interface as-is, and
> not mix two different kinds of entries: lists with 2 elements, and
> pairs.  That would avoid having to manage even more edge-cases down the
> line if some more processing is needed.

I agree.  This is a public-facing interface so we should keep it as-is;
extending it to support pairs in addition to two-list elements would
likely bring confusion and bugs.

I=E2=80=99m not entirely sure why we settled on two-list elements rather th=
an
pairs back then, but I think it=E2=80=99s OK.

Closing?

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 13 Dec 2022 20:08:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 13 15:08:02 2022
Received: from localhost ([127.0.0.1]:34345 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p5BZK-0006tr-Bj
	for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 15:08:02 -0500
Received: from tobias.gr ([80.241.217.52]:59280)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1p5BZH-0006tU-E9
 for 60014 <at> debbugs.gnu.org; Tue, 13 Dec 2022 15:08:01 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; s=2018; bh=UkfR3GFmePeci
 jdVe+CePb1oSAkUSIo2kyIQiUUeK2Y=;
 h=in-reply-to:date:subject:cc:to:
 from:references; d=tobias.gr; b=D0SQB4UoHIoAyGhajd++zSSpFugZZj5/bNgYIq
 r3MeNgXS0ELkSM+vfRBiB0WG4Y1WUb8DE1XJq6suStyUWaWSeeCoEg8UhlIyrmAB0oZny7
 JOwffNeb0CGaxvJPlLC9iliMp+jiR/p/77BnuVFYO5MaPV6febw9YunKXPWPye5/ToaMUd
 ymnuFJFOb4Dg7KTxBH+4oWK07QCTL5B0HJBi/V6h29GEsmnWsLYwXaE0F57Yanm8GsNESU
 eJXNbRQBFAacshdnFhjLcIF9N13dMx8KovqGcZlx+4d/MECDb2bzC1YXkcB3891sTqdBQC
 AriQFPR6qIeX0gC4m03+iHcA==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id 85464d42
 (TLSv1.3:AEAD-AES256-GCM-SHA384:256:NO); 
 Tue, 13 Dec 2022 20:07:53 +0000 (UTC)
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN> <87v8mgcp45.fsf@nckx>
 <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: mirai <mirai@HIDDEN>
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Date: Tue, 13 Dec 2022 21:04:42 +0100
In-reply-to: <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Message-ID: <87ilifcbgh.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 60014
Cc: Josselin Poiret <dev@HIDDEN>, 60014 <at> debbugs.gnu.org,
 guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Heyo,

mirai =E5=86=99=E9=81=93=EF=BC=9A
> This patch does: take a list of tuples, where tuples are pairs=20
> of path + file-like

This is fine.

> (and as a bonus,
> preserve existing configurations by allowing the pairs to be=20
> lists as well).

This not so much.  I guess my example was poorly chosen, but at=20
least deprecate the old style, as jpoiret also suggests.  That=20
does not mean you need to instantly break old configurations.

Kind regards,

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCY5jb/g0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15wu8A/j/W98VS3V1ZpmUcCUOYPp6a4VPmYU6nvJG0WK5n
HRXSAP9VWP0EQTX9hqy9qPoFIzUmqrvBa3JZ7zocWv0rSqWkCg==
=f60/
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Dec 2022 20:08:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 13 15:08:08 2022
Received: from localhost ([127.0.0.1]:34348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p5BZP-0006u4-Ko
	for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 15:08:08 -0500
Received: from lists.gnu.org ([209.51.188.17]:60764)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1p5BZN-0006ty-Rv
 for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 15:08:06 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>) id 1p5BZM-0006ck-46
 for guix-patches@HIDDEN; Tue, 13 Dec 2022 15:08:05 -0500
Received: from tobias.gr ([2a02:c205:2020:6054::1])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>) id 1p5BZK-0004mY-J7
 for guix-patches@HIDDEN; Tue, 13 Dec 2022 15:08:03 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; s=2018; bh=UkfR3GFmePeci
 jdVe+CePb1oSAkUSIo2kyIQiUUeK2Y=;
 h=in-reply-to:date:subject:cc:to:
 from:references; d=tobias.gr; b=D0SQB4UoHIoAyGhajd++zSSpFugZZj5/bNgYIq
 r3MeNgXS0ELkSM+vfRBiB0WG4Y1WUb8DE1XJq6suStyUWaWSeeCoEg8UhlIyrmAB0oZny7
 JOwffNeb0CGaxvJPlLC9iliMp+jiR/p/77BnuVFYO5MaPV6febw9YunKXPWPye5/ToaMUd
 ymnuFJFOb4Dg7KTxBH+4oWK07QCTL5B0HJBi/V6h29GEsmnWsLYwXaE0F57Yanm8GsNESU
 eJXNbRQBFAacshdnFhjLcIF9N13dMx8KovqGcZlx+4d/MECDb2bzC1YXkcB3891sTqdBQC
 AriQFPR6qIeX0gC4m03+iHcA==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id 85464d42
 (TLSv1.3:AEAD-AES256-GCM-SHA384:256:NO); 
 Tue, 13 Dec 2022 20:07:53 +0000 (UTC)
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN> <87v8mgcp45.fsf@nckx>
 <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: mirai <mirai@HIDDEN>
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Date: Tue, 13 Dec 2022 21:04:42 +0100
In-reply-to: <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Message-ID: <87ilifcbgh.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Received-SPF: pass client-ip=2a02:c205:2020:6054::1; envelope-from=me@HIDDEN;
 helo=tobias.gr
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
Cc: Josselin Poiret <dev@HIDDEN>, 60014 <at> debbugs.gnu.org,
 guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Heyo,

mirai =E5=86=99=E9=81=93=EF=BC=9A
> This patch does: take a list of tuples, where tuples are pairs=20
> of path + file-like

This is fine.

> (and as a bonus,
> preserve existing configurations by allowing the pairs to be=20
> lists as well).

This not so much.  I guess my example was poorly chosen, but at=20
least deprecate the old style, as jpoiret also suggests.  That=20
does not mean you need to instantly break old configurations.

Kind regards,

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCY5jb/g0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15wu8A/j/W98VS3V1ZpmUcCUOYPp6a4VPmYU6nvJG0WK5n
HRXSAP9VWP0EQTX9hqy9qPoFIzUmqrvBa3JZ7zocWv0rSqWkCg==
=f60/
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 13 Dec 2022 19:56:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 13 14:56:32 2022
Received: from localhost ([127.0.0.1]:34286 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p5BOC-0006mJ-Ai
	for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 14:56:32 -0500
Received: from jpoiret.xyz ([206.189.101.64]:57480)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dev@HIDDEN>) id 1p5BOA-0006mD-QD
 for 60014 <at> debbugs.gnu.org; Tue, 13 Dec 2022 14:56:31 -0500
Received: from authenticated-user (jpoiret.xyz [206.189.101.64])
 by jpoiret.xyz (Postfix) with ESMTPA id D9D26184F64;
 Tue, 13 Dec 2022 19:56:25 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jpoiret.xyz; s=dkim;
 t=1670961386;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=7X3jO0EEud35465ky/prN/Ym9jOwV1Pud3bGGOgHfkY=;
 b=b7vF0gscfOLJbe6kwuxPXF1VxbrRZye+0zufBhkxWfdXb2JzVtWNYVaQy9baiBNgw3Gu7C
 Dqdyn+EOVQafiIxl12LOdSX9vlG4RyxNCpx/ZJupcLPjocw/PNTK57ifq2HnZhIWWK0eYK
 Vj0iDNjJWHjgKP3iG959WAehVUyXgDbonQACJ6VoRyy5pYxkXyxaegKmYq5lw10I7D7DK6
 CpEIkaRiLMjn82nGbLZ0X2CyOeqWoAjxg0xPutX7yS8kqCHt2I+bHtMYL/QMUhzPh8+LY6
 RDdeUrBOF3ZfDT8FYWPyYpPscpHx4u07hNo8goNPZ1KtHPt9czbe6W9rdnI4Dw==
From: Josselin Poiret <dev@HIDDEN>
To: mirai <mirai@HIDDEN>, 60014 <at> debbugs.gnu.org
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
In-Reply-To: <4e874c04-8cad-6d72-379b-967721b82713@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
 <7f00edbf-8b39-0d3e-4d29-0815176d143c@HIDDEN>
 <87h6xzfw3d.fsf@HIDDEN>
 <4e874c04-8cad-6d72-379b-967721b82713@HIDDEN>
Date: Tue, 13 Dec 2022 20:56:25 +0100
Message-ID: <87bko7f57a.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Authentication-Results: jpoiret.xyz;
 auth=pass smtp.auth=jpoiret@HIDDEN smtp.mailfrom=dev@HIDDEN
X-Spamd-Bar: /
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: mirai <mirai@HIDDEN> writes: > I'm missing the link at
 [1], could you resend it? My bad, here it is 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
X-Debbugs-Envelope-To: 60014
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  mirai <mirai@HIDDEN> writes: > I'm missing the link at
    [1], could you resend it? My bad, here it is 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

mirai <mirai@HIDDEN> writes:

> I'm missing the link at [1], could you resend it?

My bad, here it is

[1] https://www.gnu.org/prep/standards/html_node/Change-Logs.html#Change-Logs
-- 
Josselin Poiret




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 13 Dec 2022 13:04:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 13 08:04:16 2022
Received: from localhost ([127.0.0.1]:60236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p54xE-00012s-4V
	for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 08:04:16 -0500
Received: from smtpmciv2.myservices.hosting ([185.26.107.238]:40852)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p54xC-00012k-5F
 for 60014 <at> debbugs.gnu.org; Tue, 13 Dec 2022 08:04:14 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv2.myservices.hosting (Postfix) with ESMTP id EF9BB20CD8;
 Tue, 13 Dec 2022 14:04:11 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id B03DF80093;
 Tue, 13 Dec 2022 14:04:11 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id mi8KAHw0Oh12; Tue, 13 Dec 2022 14:04:08 +0100 (CET)
Received: from [192.168.1.239] (unknown [10.192.1.83])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 01E6480097;
 Tue, 13 Dec 2022 14:04:07 +0100 (CET)
Message-ID: <4e874c04-8cad-6d72-379b-967721b82713@HIDDEN>
Date: Tue, 13 Dec 2022 13:04:07 +0000
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:102.0) Gecko/20100101
 Thunderbird/102.5.1
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Content-Language: en-US
To: Josselin Poiret <dev@HIDDEN>, 60014 <at> debbugs.gnu.org
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
 <7f00edbf-8b39-0d3e-4d29-0815176d143c@HIDDEN>
 <87h6xzfw3d.fsf@HIDDEN>
From: mirai <mirai@HIDDEN>
In-Reply-To: <87h6xzfw3d.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 60014
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2022-12-13 10:15, Josselin Poiret wrote:
> Hi Bruno,
> 
> mirai <mirai@HIDDEN> writes:
> 
>> The documentation for it says:
>> --8<---------------cut here---------------start------------->8---
>> The value associated with special-files-service-type services must be a list of tuples where the first element is the “special file” and the second element is its target. 
>> --8<---------------cut here---------------end--------------->8---
>>
>> Which I think is the natural way of doing it. (and communicates the intent, a pair with a path and a file-like object.)
> 
> Right, that's unfortunate, although that could be changed to “list of
> lists” to make it clearer.
> 
>> Of course, (list "path" file-like-obj) works as well but imo the pair is clearer in purpose.
>> (what meaning would the third element and so on have, if ever present?)
>> This I found out the hard way by getting strange errors until I looked into what happens behind
>> `special-files-service-type' and realizing that only lists were accepted.
>>
>> The mixing of cases is unfortunate (it should have been pairs from the start) but preserves
>> compatibility with existing syntax. 
> 

> I agree with you here, but then I think to avoid having to maintain both
> cases at the same time, all existing uses of special-files-service-type
> should also be modified, and only one kind should remain, with the other
> triggering some deprecation warning.  You could match to `(path
> . file-like)`, and if (list? file-like), throw an exception.

The `(= car target) (= cdr file)' match pattern is lifted from
https://git.savannah.gnu.org/cgit/guile.git/tree/module/ice-9/match.upstream.scm?id=b54263dc98b2700fa777745405ad7651601bcdc6#n139
as Guile's Pattern Matching page doesn't specify how to match against pairs when I was looking into it.

> As a sidenote, the main problem is that Guile is not a statically typed
> language, but that's a whole other debate to have.
> 
> In any case, I don't think this patch will be accepted as-is.  I would
> only be partially in favor of the second solution (because it breaks
> existing code), while the first solution is low-effort and should work
> well enough.  Up to you (and maintainers) to decide.

A breaking change here (or a non-breaking "deprecated" warning similar to how
bootloader target field was renamed to targets can be done too, but before
any further changes its best to discuss if such a change will be received.


On 2022-12-12 20:34, Josselin Poiret wrote:
> Otherwise, you're missing the ChangeLog entry format for the commit
> message, which you can find described at [1].  You can take some
> inspiration from other commits in the repository.

I'm missing the link at [1], could you resend it?

Cheers,
Bruno




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 13 Dec 2022 10:15:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 13 05:15:40 2022
Received: from localhost ([127.0.0.1]:59449 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p52K4-0002ol-53
	for submit <at> debbugs.gnu.org; Tue, 13 Dec 2022 05:15:40 -0500
Received: from jpoiret.xyz ([206.189.101.64]:46732)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dev@HIDDEN>) id 1p52K2-0002od-9I
 for 60014 <at> debbugs.gnu.org; Tue, 13 Dec 2022 05:15:38 -0500
Received: from authenticated-user (jpoiret.xyz [206.189.101.64])
 by jpoiret.xyz (Postfix) with ESMTPA id 34A4B185315;
 Tue, 13 Dec 2022 10:15:35 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jpoiret.xyz; s=dkim;
 t=1670926535;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:mime-version:mime-version:content-type:content-type:
 content-transfer-encoding:content-transfer-encoding:
 in-reply-to:in-reply-to:references:references;
 bh=QVQkQ1A5Q/lfiM6e7sn/W/kL2AcM9hKiqwV9d6R14vc=;
 b=wfrRPpWdKkxCtl/ZCOcoKA9RFZZsWtNrRcFYv10Ve2GFBxu1eiQ0NR2gP7GMjzTTyfaRTc
 Cio6R10p6OQSk8pwHr5ZpGy3Di7dMmR0+4ONaHyBIjb9qCyD0tpvWS3ZkXEDb7AXiS+ldl
 2LNA1zobhjp7/aUMVeaZ5ro7OAa2VXdf/msqBo3kKryMYdVFk0hpvzEpmPXlvj2Mb8JzD8
 CsuwVZRYjqIcLOtQV6e3FGZ5PNDxOLKK1ZGgtqa5ZmlHovznl3rPACUq3vyIGRcUera9lt
 6x7fvcBUmCSytBIfXfsyTQlHS7nwD6MwoC6g4rBUJAHpHr0Ax0d45f9Uu9Scsw==
From: Josselin Poiret <dev@HIDDEN>
To: mirai <mirai@HIDDEN>, 60014 <at> debbugs.gnu.org
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
In-Reply-To: <7f00edbf-8b39-0d3e-4d29-0815176d143c@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
 <7f00edbf-8b39-0d3e-4d29-0815176d143c@HIDDEN>
Date: Tue, 13 Dec 2022 11:15:34 +0100
Message-ID: <87h6xzfw3d.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
Authentication-Results: jpoiret.xyz;
 auth=pass smtp.auth=jpoiret@HIDDEN smtp.mailfrom=dev@HIDDEN
X-Spamd-Bar: /
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi Bruno,
 mirai <mirai@HIDDEN> writes: > The documentation
 for it says: > --8<cut herestart>8--- > The value associated with
 special-files-service-type
 services must be a list of tuples where the [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
X-Debbugs-Envelope-To: 60014
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi Bruno, mirai <mirai@HIDDEN> writes: > The documentation
    for it says: > --8<cut herestart>8--- > The value associated with special-files-service-type
    services must be a list of tuples where the [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

Hi Bruno,

mirai <mirai@HIDDEN> writes:

> The documentation for it says:
> --8<---------------cut here---------------start------------->8---
> The value associated with special-files-service-type services must be a l=
ist of tuples where the first element is the =E2=80=9Cspecial file=E2=80=9D=
 and the second element is its target.=20
> --8<---------------cut here---------------end--------------->8---
>
> Which I think is the natural way of doing it. (and communicates the inten=
t, a pair with a path and a file-like object.)

Right, that's unfortunate, although that could be changed to =E2=80=9Clist =
of
lists=E2=80=9D to make it clearer.

> Of course, (list "path" file-like-obj) works as well but imo the pair is =
clearer in purpose.
> (what meaning would the third element and so on have, if ever present?)
> This I found out the hard way by getting strange errors until I looked in=
to what happens behind
> `special-files-service-type' and realizing that only lists were accepted.
>
> The mixing of cases is unfortunate (it should have been pairs from the st=
art) but preserves
> compatibility with existing syntax.=20

I agree with you here, but then I think to avoid having to maintain both
cases at the same time, all existing uses of special-files-service-type
should also be modified, and only one kind should remain, with the other
triggering some deprecation warning.  You could match to `(path
. file-like)`, and if (list? file-like), throw an exception.

As a sidenote, the main problem is that Guile is not a statically typed
language, but that's a whole other debate to have.

In any case, I don't think this patch will be accepted as-is.  I would
only be partially in favor of the second solution (because it breaks
existing code), while the first solution is low-effort and should work
well enough.  Up to you (and maintainers) to decide.

Best,
--=20
Josselin Poiret




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 12 Dec 2022 22:25:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 17:25:13 2022
Received: from localhost ([127.0.0.1]:55797 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4rEX-00050K-Gr
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:25:13 -0500
Received: from smtpmciv5.myservices.hosting ([185.26.107.241]:45324)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p4rEV-00050B-6b
 for 60014 <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:25:11 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv5.myservices.hosting (Postfix) with ESMTP id DD2922076C;
 Mon, 12 Dec 2022 23:25:06 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id 8ACDE80097;
 Mon, 12 Dec 2022 23:25:06 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id hQwEoMRXwOUY; Mon, 12 Dec 2022 23:25:06 +0100 (CET)
Received: from [192.168.1.239] (unknown [10.192.1.83])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 0FB7280093;
 Mon, 12 Dec 2022 23:25:05 +0100 (CET)
Message-ID: <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
Date: Mon, 12 Dec 2022 22:25:05 +0000
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:102.0) Gecko/20100101
 Thunderbird/102.5.1
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Content-Language: en-US
To: Tobias Geerinckx-Rice <me@HIDDEN>, Josselin Poiret <dev@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN> <87v8mgcp45.fsf@nckx>
From: mirai <mirai@HIDDEN>
In-Reply-To: <87v8mgcp45.fsf@nckx>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 60014
Cc: 60014 <at> debbugs.gnu.org, guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2022-12-12 20:52, Tobias Geerinckx-Rice wrote:
> Josselin Poiret via Guix-patches via 写道:
>> I personally would prefer keeping the special file interface as-is, and
>> not mix two different kinds of entries: lists with 2 elements, and
>> pairs.  That would avoid having to manage even more edge-cases down the
>> line if some more processing is needed.
> 
> I agree with this reasoning, and would go as far as to say that if this fixes anything, that thing should probably be fixed instead…?
> 
> ‘Takes a list of As, but as a special case, a single A’ is confusing and makes it that much harder for newcomers to move beyond cargo-culting magical snippets.

That's not what's happening here, right now what guix does is: take a list of tuples, where tuples are 2-element lists of path + file-like.
This patch does: take a list of tuples, where tuples are pairs of path + file-like (and as a bonus,
preserve existing configurations by allowing the pairs to be lists as well).




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Dec 2022 22:25:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 17:25:16 2022
Received: from localhost ([127.0.0.1]:55800 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4rEZ-00050X-On
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:25:16 -0500
Received: from lists.gnu.org ([209.51.188.17]:50222)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p4rEY-00050R-9V
 for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:25:14 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mirai@HIDDEN>) id 1p4rEY-0006Ad-2x
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 17:25:14 -0500
Received: from smtpmciv5.myservices.hosting ([185.26.107.241])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mirai@HIDDEN>) id 1p4rEW-0001fV-H5
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 17:25:13 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv5.myservices.hosting (Postfix) with ESMTP id DD2922076C;
 Mon, 12 Dec 2022 23:25:06 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id 8ACDE80097;
 Mon, 12 Dec 2022 23:25:06 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id hQwEoMRXwOUY; Mon, 12 Dec 2022 23:25:06 +0100 (CET)
Received: from [192.168.1.239] (unknown [10.192.1.83])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 0FB7280093;
 Mon, 12 Dec 2022 23:25:05 +0100 (CET)
Message-ID: <cc11dcaa-3acd-dd47-0c80-1a98197c9738@HIDDEN>
Date: Mon, 12 Dec 2022 22:25:05 +0000
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:102.0) Gecko/20100101
 Thunderbird/102.5.1
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Content-Language: en-US
To: Tobias Geerinckx-Rice <me@HIDDEN>, Josselin Poiret <dev@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN> <87v8mgcp45.fsf@nckx>
From: mirai <mirai@HIDDEN>
In-Reply-To: <87v8mgcp45.fsf@nckx>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
Received-SPF: pass client-ip=185.26.107.241; envelope-from=mirai@HIDDEN;
 helo=smtpmciv5.myservices.hosting
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, NICE_REPLY_A=-0.001,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: 60014 <at> debbugs.gnu.org, guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

On 2022-12-12 20:52, Tobias Geerinckx-Rice wrote:
> Josselin Poiret via Guix-patches via 写道:
>> I personally would prefer keeping the special file interface as-is, and
>> not mix two different kinds of entries: lists with 2 elements, and
>> pairs.  That would avoid having to manage even more edge-cases down the
>> line if some more processing is needed.
> 
> I agree with this reasoning, and would go as far as to say that if this fixes anything, that thing should probably be fixed instead…?
> 
> ‘Takes a list of As, but as a special case, a single A’ is confusing and makes it that much harder for newcomers to move beyond cargo-culting magical snippets.

That's not what's happening here, right now what guix does is: take a list of tuples, where tuples are 2-element lists of path + file-like.
This patch does: take a list of tuples, where tuples are pairs of path + file-like (and as a bonus,
preserve existing configurations by allowing the pairs to be lists as well).




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 12 Dec 2022 22:09:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 17:09:55 2022
Received: from localhost ([127.0.0.1]:55699 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4qzj-0004ma-At
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:09:55 -0500
Received: from smtpmciv2.myservices.hosting ([185.26.107.238]:43330)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p4qzh-0004mU-Ak
 for 60014 <at> debbugs.gnu.org; Mon, 12 Dec 2022 17:09:53 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv2.myservices.hosting (Postfix) with ESMTP id 075A920BFB;
 Mon, 12 Dec 2022 23:09:50 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id B3CC380097;
 Mon, 12 Dec 2022 23:09:50 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id g1Yocgsfr4KQ; Mon, 12 Dec 2022 23:09:50 +0100 (CET)
Received: from [192.168.1.239] (unknown [10.192.1.83])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 47D5380096;
 Mon, 12 Dec 2022 23:09:50 +0100 (CET)
Message-ID: <7f00edbf-8b39-0d3e-4d29-0815176d143c@HIDDEN>
Date: Mon, 12 Dec 2022 22:09:49 +0000
MIME-Version: 1.0
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:102.0) Gecko/20100101
 Thunderbird/102.5.1
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Content-Language: en-US
To: Josselin Poiret <dev@HIDDEN>, 60014 <at> debbugs.gnu.org
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
From: mirai <mirai@HIDDEN>
In-Reply-To: <87k02wfjk5.fsf@HIDDEN>
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 60014
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2022-12-12 20:34, Josselin Poiret wrote:
> Hi Bruno, 
> 
> Is this patch related to some specific problem you're running into?  I
> personally would prefer keeping the special file interface as-is, and
> not mix two different kinds of entries: lists with 2 elements, and
> pairs.  That would avoid having to manage even more edge-cases down the
> line if some more processing is needed.

I'm writing a service definition that uses a special-files-service-type service-extension.
The documentation for it says:
--8<---------------cut here---------------start------------->8---
The value associated with special-files-service-type services must be a list of tuples where the first element is the “special file” and the second element is its target. 
--8<---------------cut here---------------end--------------->8---

I assume a pair is a reasonable interpretation of 'tuples' in this context, so I proceeded to serialize the fields with:
--8<---------------cut here---------------start------------->8---
(cons "filename here" (mixed-text-file "filename" contents ...))
--8<---------------cut here---------------end--------------->8---

Which I think is the natural way of doing it. (and communicates the intent, a pair with a path and a file-like object.)

Of course, (list "path" file-like-obj) works as well but imo the pair is clearer in purpose.
(what meaning would the third element and so on have, if ever present?)
This I found out the hard way by getting strange errors until I looked into what happens behind
`special-files-service-type' and realizing that only lists were accepted.

The mixing of cases is unfortunate (it should have been pairs from the start) but preserves
compatibility with existing syntax. 




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Dec 2022 21:01:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 16:01:27 2022
Received: from localhost ([127.0.0.1]:55349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4pvT-0003zo-EI
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 16:01:27 -0500
Received: from lists.gnu.org ([209.51.188.17]:45014)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1p4pvS-0003zi-E0
 for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 16:01:26 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>) id 1p4pvC-0003RD-3l
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 16:01:23 -0500
Received: from tobias.gr ([2a02:c205:2020:6054::1])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>) id 1p4pv5-00037Y-M2
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 16:01:06 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; s=2018; bh=8n+g4AhQMdsHZ
 kuTBupMoJhfuloKTqJyWSy3HFv734g=;
 h=in-reply-to:date:subject:cc:to:
 from:references; d=tobias.gr; b=TY6xZsmXUUWKObkj5+MXnJZ6Nx4cx3yL5han5g
 CXmh1YZyOKrn4mxeKQSRlxcxt2m8dUKPihHEIw7/jxpaJ00r4iCmhTUkDgU44gz/s/xx7L
 E8drKgiwA9A2mGwd1Q/I6BRVZ4BK6MdDOMHngTDHnTJnxSsunNRqleQunuRlJLIAcr777D
 cn3PRUoa3qQPgiGiGgZa8A4/pvTPqg3vg7zPb6cFURyVI87geyEdB+ikisjKW8PUC9g4/N
 2NqVcXFKN6wWk+Fx9/Ge4vnEx+xkPvZ0sbyn2MWcDttQj6ESDlazYlKyh58aF9W5U63x0e
 ImnLLo7LkZGg9l4au6sAKedQ==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id 76c7d4de
 (TLSv1.3:AEAD-AES256-GCM-SHA384:256:NO); 
 Mon, 12 Dec 2022 21:00:37 +0000 (UTC)
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: Josselin Poiret <dev@HIDDEN>
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Date: Mon, 12 Dec 2022 21:52:46 +0100
In-reply-to: <87k02wfjk5.fsf@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Message-ID: <87v8mgcp45.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Received-SPF: pass client-ip=2a02:c205:2020:6054::1; envelope-from=me@HIDDEN;
 helo=tobias.gr
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
Cc: 60014 <at> debbugs.gnu.org, Bruno Victal <mirai@HIDDEN>,
 guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Josselin Poiret via Guix-patches via =E5=86=99=E9=81=93=EF=BC=9A
> I personally would prefer keeping the special file interface=20
> as-is, and
> not mix two different kinds of entries: lists with 2 elements,=20
> and
> pairs.  That would avoid having to manage even more edge-cases=20
> down the
> line if some more processing is needed.

I agree with this reasoning, and would go as far as to say that if=20
this fixes anything, that thing should probably be fixed instead=E2=80=A6?

=E2=80=98Takes a list of As, but as a special case, a single A=E2=80=99 is=
=20
confusing and makes it that much harder for newcomers to move=20
beyond cargo-culting magical snippets.

Kind regards,

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCY5eW2g0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15m4YA/0cLEmsPszjIfH/blAGdD/CmL1BCexW72y1CVFdP
eMq5AQDR/cPdCRqZTHImc1GSwi/WsY1Poc8035zOCG6NSc/JDw==
=jSFi
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 12 Dec 2022 21:00:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 16:00:50 2022
Received: from localhost ([127.0.0.1]:55339 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4pur-0003yX-Ok
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 16:00:50 -0500
Received: from tobias.gr ([80.241.217.52]:57930)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1p4puo-0003yR-Aa
 for 60014 <at> debbugs.gnu.org; Mon, 12 Dec 2022 16:00:47 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; s=2018; bh=8n+g4AhQMdsHZ
 kuTBupMoJhfuloKTqJyWSy3HFv734g=;
 h=in-reply-to:date:subject:cc:to:
 from:references; d=tobias.gr; b=TY6xZsmXUUWKObkj5+MXnJZ6Nx4cx3yL5han5g
 CXmh1YZyOKrn4mxeKQSRlxcxt2m8dUKPihHEIw7/jxpaJ00r4iCmhTUkDgU44gz/s/xx7L
 E8drKgiwA9A2mGwd1Q/I6BRVZ4BK6MdDOMHngTDHnTJnxSsunNRqleQunuRlJLIAcr777D
 cn3PRUoa3qQPgiGiGgZa8A4/pvTPqg3vg7zPb6cFURyVI87geyEdB+ikisjKW8PUC9g4/N
 2NqVcXFKN6wWk+Fx9/Ge4vnEx+xkPvZ0sbyn2MWcDttQj6ESDlazYlKyh58aF9W5U63x0e
 ImnLLo7LkZGg9l4au6sAKedQ==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id 76c7d4de
 (TLSv1.3:AEAD-AES256-GCM-SHA384:256:NO); 
 Mon, 12 Dec 2022 21:00:37 +0000 (UTC)
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
 <87k02wfjk5.fsf@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: Josselin Poiret <dev@HIDDEN>
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
Date: Mon, 12 Dec 2022 21:52:46 +0100
In-reply-to: <87k02wfjk5.fsf@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Message-ID: <87v8mgcp45.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 60014
Cc: 60014 <at> debbugs.gnu.org, Bruno Victal <mirai@HIDDEN>,
 guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Josselin Poiret via Guix-patches via =E5=86=99=E9=81=93=EF=BC=9A
> I personally would prefer keeping the special file interface=20
> as-is, and
> not mix two different kinds of entries: lists with 2 elements,=20
> and
> pairs.  That would avoid having to manage even more edge-cases=20
> down the
> line if some more processing is needed.

I agree with this reasoning, and would go as far as to say that if=20
this fixes anything, that thing should probably be fixed instead=E2=80=A6?

=E2=80=98Takes a list of As, but as a special case, a single A=E2=80=99 is=
=20
confusing and makes it that much harder for newcomers to move=20
beyond cargo-culting magical snippets.

Kind regards,

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCY5eW2g0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15m4YA/0cLEmsPszjIfH/blAGdD/CmL1BCexW72y1CVFdP
eMq5AQDR/cPdCRqZTHImc1GSwi/WsY1Poc8035zOCG6NSc/JDw==
=jSFi
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at 60014 <at> debbugs.gnu.org:


Received: (at 60014) by debbugs.gnu.org; 12 Dec 2022 20:34:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 15:34:10 2022
Received: from localhost ([127.0.0.1]:55214 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4pV3-0003dw-Kp
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 15:34:09 -0500
Received: from jpoiret.xyz ([206.189.101.64]:58714)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dev@HIDDEN>) id 1p4pV1-0003dq-U4
 for 60014 <at> debbugs.gnu.org; Mon, 12 Dec 2022 15:34:08 -0500
Received: from authenticated-user (jpoiret.xyz [206.189.101.64])
 by jpoiret.xyz (Postfix) with ESMTPA id B8C9B1851DF;
 Mon, 12 Dec 2022 20:34:02 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jpoiret.xyz; s=dkim;
 t=1670877243;
 h=from:from:reply-to:subject:subject:date:date:message-id:message-id:
 to:to:cc:cc:mime-version:mime-version:content-type:content-type:
 in-reply-to:in-reply-to:references:references;
 bh=AUZX8qb1UKu2V1qyU9Sl4ZztHdwPVhB6v5PpZ1dkXkU=;
 b=Pyysp+NfHpstkVODU7QR/8tuHKEdmw3apg1pfUn4K3ER+G1ddmiu3nAFj2mDCj+MMFS9Vz
 dCKddLxMf6BF5Qc5yyI1PrkrgOKe0UMY1R2lXoB+drRF1IMHWiWERUC1NOCZavfMe87Fjb
 ePKh/3Sf/TzIHENmg8GZq89n5lwhkraaHUrvHq1jaX/jNjJIv4tBjRjoqwqv/f1eXp9xr1
 +mxypkbVAPoZCQRUIjO2/c1OC3L2jhXXSdFdXUrLNGQdG5vSCCFdg+0dTqnv4RcUALdj88
 ovLGD3iYqYKj+zUfoQuQGdL9dY8xzsP2YN9oY+lRmDliYVPWzvkvX18QPHkD5g==
From: Josselin Poiret <dev@HIDDEN>
To: mirai@HIDDEN, 60014 <at> debbugs.gnu.org
Subject: Re: [bug#60014] [PATCH] activation: make install-special-file match
 against pairs as well.
In-Reply-To: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
References: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
Date: Mon, 12 Dec 2022 21:34:02 +0100
Message-ID: <87k02wfjk5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Authentication-Results: jpoiret.xyz;
 auth=pass smtp.auth=jpoiret@HIDDEN smtp.mailfrom=dev@HIDDEN
X-Spamd-Bar: /
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi Bruno,
 Is this patch related to some specific problem you're
 running into? I personally would prefer keeping the special file interface
 as-is, and not mix two different kinds of entries: lists with 2 element [...]
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
 [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
X-Debbugs-Envelope-To: 60014
Cc: Bruno Victal <mirai@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hi Bruno, Is this patch related to some specific problem you're
    running into? I personally would prefer keeping the special file interface
    as-is, and not mix two different kinds of entries: lists with 2 element [...]
    
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  2.0 PDS_OTHER_BAD_TLD      Untrustworthy TLDs
                             [URI: jpoiret.xyz (xyz)]
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
  1.0 BULK_RE_SUSP_NTLD      Precedence bulk and RE: from a suspicious TLD
  0.0 FROM_SUSPICIOUS_NTLD   From abused NTLD
 -1.0 MAILING_LIST_MULTI     Multiple indicators imply a widely-seen list
                             manager

Hi Bruno, 

Is this patch related to some specific problem you're running into?  I
personally would prefer keeping the special file interface as-is, and
not mix two different kinds of entries: lists with 2 elements, and
pairs.  That would avoid having to manage even more edge-cases down the
line if some more processing is needed.

Otherwise, you're missing the ChangeLog entry format for the commit
message, which you can find described at [1].  You can take some
inspiration from other commits in the repository.

Best,
-- 
Josselin Poiret




Information forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 12 Dec 2022 17:46:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 12 12:46:24 2022
Received: from localhost ([127.0.0.1]:54358 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1p4msh-0001ZI-UK
	for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 12:46:24 -0500
Received: from lists.gnu.org ([209.51.188.17]:40022)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mirai@HIDDEN>) id 1p4msf-0001ZB-30
 for submit <at> debbugs.gnu.org; Mon, 12 Dec 2022 12:46:22 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mirai@HIDDEN>) id 1p4mse-000887-RB
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 12:46:20 -0500
Received: from smtpmciv5.myservices.hosting ([185.26.107.241])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <mirai@HIDDEN>) id 1p4msc-0001X0-BC
 for guix-patches@HIDDEN; Mon, 12 Dec 2022 12:46:19 -0500
Received: from mail1.netim.hosting (unknown [185.26.106.172])
 by smtpmciv5.myservices.hosting (Postfix) with ESMTP id 605C820491
 for <guix-patches@HIDDEN>; Mon, 12 Dec 2022 18:46:05 +0100 (CET)
Received: from localhost (localhost [127.0.0.1])
 by mail1.netim.hosting (Postfix) with ESMTP id 1349280096;
 Mon, 12 Dec 2022 18:46:05 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at mail1.netim.hosting
Received: from mail1.netim.hosting ([127.0.0.1])
 by localhost (mail1-1.netim.hosting [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id tLSuHF4fyJbW; Mon, 12 Dec 2022 18:46:04 +0100 (CET)
Received: from guix-nuc.home.arpa (bl12-93-156.dsl.telepac.pt [85.245.93.156])
 (Authenticated sender: lumen@HIDDEN)
 by mail1.netim.hosting (Postfix) with ESMTPSA id 6D53580093;
 Mon, 12 Dec 2022 18:46:04 +0100 (CET)
From: mirai@HIDDEN
To: guix-patches@HIDDEN
Subject: [PATCH] activation: make install-special-file match against pairs as
 well.
Date: Mon, 12 Dec 2022 17:45:47 +0000
Message-Id: <43e937e1625b47a80887e68847fb8a8811d3f39f.1670867103.git.mirai@HIDDEN>
X-Mailer: git-send-email 2.38.1
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
Received-SPF: pass client-ip=185.26.107.241; envelope-from=mirai@HIDDEN;
 helo=smtpmciv5.myservices.hosting
X-Spam_score_int: -18
X-Spam_score: -1.9
X-Spam_bar: -
X-Spam_report: (-1.9 / 5.0 requ) BAYES_00=-1.9, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Bruno Victal <mirai@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

From: Bruno Victal <mirai@HIDDEN>

special-files is a list of 2-tuples (pairs) but matching against
a non-list pair would fail as match-lambda was only matching
against a list pattern.
---
 gnu/build/activation.scm | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/gnu/build/activation.scm b/gnu/build/activation.scm
index 10c9045740..d4a7559651 100644
--- a/gnu/build/activation.scm
+++ b/gnu/build/activation.scm
@@ -341,7 +341,7 @@ (define (activate-special-files special-files)
 "
   (define install-special-file
     (match-lambda
-      ((target file)
+      ((or (target file) (? pair? (= car target) (= cdr file)))
        (let ((pivot (string-append target ".new")))
          (mkdir-p (dirname target))
          (symlink file pivot)

base-commit: 5fb5af5658b7575a945579a7cf51c193600b76bb
-- 
2.38.1





Acknowledgement sent to mirai@HIDDEN:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#60014; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 21 Dec 2022 13:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.